﻿//ドキュメント確認
app.activate();
if(app.documents.length==0){
alert("InDesignドキュメントを開いてから実行してください。");
exit() ;
}else if(app.documents.length>1){
	alert("複数のInDesignドキュメントを開いている場合、最前面ドキュメントのみが処理対象となります。");
	}
if(app.documents[0].saved==false){
		alert("処理対象のInDesignドキュメントを保存してから実行してください。");
		exit() ;
}

//外部テキストファイルを用意
now = new Date();
myYear = now.getFullYear();
myMonth=now.getMonth()+1;
myDate=now.getDate();
myHours=now.getHours();
myMinutes=now.getMinutes();
mySeconds=now.getSeconds();
nowTime= myYear +"-"+myMonth+"-"+myDate+"-"+myHours+"-"+myMinutes+"-"+mySeconds;
saveFolderPath = app.documents[0].filePath; // ドキュメントの保存フォルダ
fileObj = new File(saveFolderPath +"/【"+app.documents[0].name+"】"+ nowTime+".txt");
fileObj.encoding="UTF8";

///一覧を生成
var doc = app.documents[0] ;
var ngList=new String;
ngList=("");

//検索オプションGrep
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうか

//文字スタイル読み込み
var slist = "";
for (i = 0; i < app.activeDocument.characterStyles.length; i++) {
	slist = slist + app.activeDocument.characterStyles[i].name + ",";
	}
for (i = 0; i < app.activeDocument.characterStyleGroups.length; i++) {
	var tmpStr = app.activeDocument.characterStyleGroups[i].name
	for (j = 0; j < app.activeDocument.characterStyleGroups[i].characterStyles.length; j++) {
		slist = slist + tmpStr + " __ " + app.activeDocument.characterStyleGroups[i].characterStyles[j].name + ",";
		}
	}
slist = slist.replace ("[なし]", "");
slist = slist.substring (0, slist.length-1);
slist = slist.split (",");

//ダイアログ表示
var dlg = app.dialogs.add({name:"文字スタイル選択"});
var dlc = dlg.dialogColumns.add();

with(dlc.dialogRows.add()){ 
var tmp = dlc.dialogRows.add()
tmp.staticTexts.add({staticLabel:"↓索引化する文字スタイルを選択してください。", minWidth:120 });
}

with(dlc.dialogRows.add()){ 
	var myCStyle = dropdowns.add({stringList: slist, selectedIndex:0, minWidth:120});
	}
flag =dlg.show();
 if (flag == true){
//文字スタイル取り出し
var tmpCStyle = myCStyle.stringList[myCStyle.selectedIndex];
if (tmpCStyle.match (" __ ")) {
	var CStyle = tmpCStyle.split(" __ ");
//alert(CStyle[0]);
//alert(CStyle[1]);
app.findGrepPreferences.appliedCharacterStyle = doc.characterStyleGroups.itemByName(CStyle[0]).characterStyles.itemByName(CStyle[1]);
	} else {
//alert(tmpCStyle);
app.findGrepPreferences.appliedCharacterStyle = doc.characterStyles.itemByName(tmpCStyle);
		}
}
app.findGrepPreferences.findWhat=""

var gr=doc.findGrep(); // 検索だけ
var grl=gr.length; 

for (i=0; i<grl; i++) { 
try{	
	ngList=(ngList+"\r"+gr[i].contents+"\t"+gr[i].parentTextFrames[0].parentPage.name);
}catch(e){}
}
ngList=ngList.replace(/[\u0007\u0003\u200C\n\u0004]/g,"");	//「ここまでインデント」文字、先頭文字スタイルの終了文字、結合なし、強制改行、脚注番号マーカを削除
ngList=ngList.replace(/^\r/g,""); 

flag = fileObj.open("w");
if (flag){
fileObj.writeln(ngList);
fileObj.close();

////ソート/////

//文字列を生成
//var ngList=new String;
ngList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
TAB = String.fromCharCode(9);	// タブコード

while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var  lineNum = countA ;	//行数
var rowNum = txtItemA.length;	//列数
}
function funcCompare(a, b) {
	if (a[0] < b[0]) return -1;
	if (a[0] > b[0]) return 1;

	if (a[rowNum-1]*1 < b[rowNum-1]*1) return -1;
	if (a[rowNum-1]*1 > b[rowNum-1]*1) return 1;
	return 0;
}
var newAry=ary.sort(funcCompare);
var aLength = newAry.length;

for( i=0 ; i<aLength ; i++ ){
var newTxt = newAry[i].join( "\t" );
ngList = ngList + newTxt + "\r" ;
}
flag = fileObj.open("w");
if (flag){
fileObj.writeln(ngList);
fileObj.close();
}

/////重複削除/////

//var ngList=new String;
ngList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;
while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA);//配列の最後に行を追加
countA++;
}
var rowNum = txtItemA.length;	//列数
}

//語句（1列目）とノンブル（最終列）が重複していたら行を削除する。
for( i=ary.length-1 ; i>0 ; i-- ){
if( ary[i][0]==ary[i-1][0] && ary[i][rowNum-1]==ary[i-1][rowNum-1] ){
//alert(ary[i][0]);
ary.splice(i, 1);
}
}

//語句（1列目）の重複があったらノンブルを「, 」区切りでまとめる。
for( j=ary.length-1 ; j>0 ; j-- ){
if( ary[j][0]==ary[j-1][0] ){
//alert(ary[i][0]);
ary[j-1][rowNum-1]=ary[j-1][rowNum-1]+", "+ary[j][rowNum-1];
ary.splice(j, 1);
}
}

//ファイルに書き込み保存。
for( k=0 ; k<ary.length ; k++ ){
var newTxt = ary[k].join( "\t" );
ngList = ngList + newTxt + "\r" ;
}
flag = fileObj.open("w");
if (flag){
fileObj.writeln(ngList);
fileObj.close();
};
var docName = app.documents[0].name.replace(/\.indd/g,"");;
var stName = tmpCStyle.replace(/ __ /g,"_");

fileObj.rename( docName+"（"+stName+"）"+ nowTime+".txt");
}else{
alert("ファイルが作成できません。アクセス権があるか確認してください");
}